/*describes the data for the paper*/
set more off
capture log close

log using desc.txt, text replace

gen parttime = sp_hours<35  if sp_employed==1
gen fulltime = sp_hours>=35 if sp_employed==1

gen parttime_20 = sp_hours<20  if sp_employed==1
gen fulltime_20 = sp_hours>=20 if sp_employed==1

/*1980*/

su numdepchild if yr==1980

su sp_educ1 if yr==1980
su sp_educ2 if yr==1980
su sp_educ3 if yr==1980
su sp_educ4 if yr==1980

su sp_hours if yr==1980 & sp_employed==1
su sp_hours if yr==1980 & sp_educ==1 & sp_employed==1
su sp_hours if yr==1980 & sp_educ==2 & sp_employed==1
su sp_hours if yr==1980 & sp_educ==3 & sp_employed==1
su sp_hours if yr==1980 & sp_educ==4 & sp_employed==1

su sp_w if yr==1980
su sp_w if yr==1980 & sp_educ==1
su sp_w if yr==1980 & sp_educ==2
su sp_w if yr==1980 & sp_educ==3
su sp_w if yr==1980 & sp_educ==4

su sp_employed if yr==1980
su parttime if yr==1980

/*1995*/

su numdepchild if yr==1995

su sp_educ1 if yr==1995
su sp_educ2 if yr==1995
su sp_educ3 if yr==1995
su sp_educ4 if yr==1995

su sp_hours if yr==1995 & sp_employed==1
su sp_hours if yr==1995 & sp_educ==1 & sp_employed==1
su sp_hours if yr==1995 & sp_educ==2 & sp_employed==1
su sp_hours if yr==1995 & sp_educ==3 & sp_employed==1
su sp_hours if yr==1995 & sp_educ==4 & sp_employed==1

su sp_w if yr==1995
su sp_w if yr==1995 & sp_educ==1
su sp_w if yr==1995 & sp_educ==2
su sp_w if yr==1995 & sp_educ==3
su sp_w if yr==1995 & sp_educ==4

su sp_employed if yr==1995
su parttime if yr==1995

/*2012*/

su numdepchild if yr==2012

su sp_educ1 if yr==2012
su sp_educ2 if yr==2012
su sp_educ3 if yr==2012
su sp_educ4 if yr==2012

su sp_hours if yr==2012 & sp_employed==1
su sp_hours if yr==2012 & sp_educ==1 & sp_employed==1
su sp_hours if yr==2012 & sp_educ==2 & sp_employed==1
su sp_hours if yr==2012 & sp_educ==3 & sp_employed==1
su sp_hours if yr==2012 & sp_educ==4 & sp_employed==1

su sp_w if yr==2012
su sp_w if yr==2012 & sp_educ==1
su sp_w if yr==2012 & sp_educ==2
su sp_w if yr==2012 & sp_educ==3
su sp_w if yr==2012 & sp_educ==4

su sp_employed if yr==2012
su parttime if yr==2012

log close

drop parttime fulltime
drop parttime_20
drop fulltime_20
