!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine calibrate
use inputs
use statistics
use params
implicit none
double precision::  rannum, time1, time2 !,guess(numtargets)

INTEGER::cont,var(numtargets),randier, ii, jj1, w, p, ww, pp, t, q, edad, j_frisch, startfrisch,endfrisch

character*4::name1,name2,name3,name4,name5


external partner

open (unit=10,  file ='../Outputs/dump.out')             
open (unit=12, RECL=2000,file ='../Outputs/dump2.out')             


!1--------READ PARAMETER VALUES TO NODE 1 AND BROADCAST TO THE OTHER NODES
if (id==0) then
	call reading1
endif

 
call MPI_BCAST(quarter,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(nt,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(ret,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(na,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(nw,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(noexp,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(lown,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(uppn,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(maxit,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(pnw,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(nosims,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(minass,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(xtol,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(maxim,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(growth,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(upper,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(nu,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(detrr,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(meandisc,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(disc,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(variance,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(pvariance,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(corrho,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)

call MPI_BCAST(inithk,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(hours,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(hoursfix,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(minhours,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(nokids,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(kid_1,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(kid_2,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(kid_3,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(kid_4,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(kid_5,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(kid_6,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(kid_7,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(kid_8,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(kid_9,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(propkid_1,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(propkid_2,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(propkid_3,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(propkid_4,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(propkid_5,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(propkid_6,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(propkid_7,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(propkid_8,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(propkid_9,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(alfaL,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(alfaM,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(alfaH,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(mm,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(ssi,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(fullfrac,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(edu,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(chcostfunc1,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(chcostfunc2,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(chcostfunc3,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(chcostfunc4,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(chcostfunc5,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(chcostfunc6,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(chcostfunc7,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(chcostfunc8,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(borrowdum,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(Icycle,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(Isample,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)

call MPI_BCAST(coef0,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(coefage1,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(coefage2,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(coefage3,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(coefage4,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(coefchild1,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(coefchild2,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(coefchild3,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(coefsize,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(coefhaskid,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(coefc,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(coefnc,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)

call MPI_BCAST(hourseis,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)


kid=(/kid_1,kid_2,kid_3,kid_4,kid_5,kid_6,kid_7,kid_8,kid_9/)
propkid=(/propkid_1,propkid_2,propkid_3,propkid_4,propkid_5,propkid_6,propkid_7,propkid_8,propkid_9/)
chcostfunc=(/chcostfunc1,chcostfunc2,chcostfunc3,chcostfunc4,chcostfunc5,chcostfunc6,chcostfunc7,chcostfunc8/)


!2--------READ GUESS FOR PARAMETER VALUES TO NODE 1 AND BROADCAST TO THE OTHER NODES
if(id==0)then
	if(edu.eq.0)then
		open(unit=999, file ='../Inteninps/mpiguess.inp')
	elseif(edu.eq.1)then
		open(unit=999, file ='../Inteninps/mpiguessNC.inp')
	else
		open(unit=999, file ='../Inteninps/mpiguessC.inp')
	endif
	do cont=1,numtargets
		read (999,*) guess(cont)
		
	enddo
	close(999)
endif


if(ID==0)write(*,*)numtargets
do cont=1,numtargets
	call MPI_BCAST(guess(cont),1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
	if(ID==0)write(*,*)cont,guess(cont)
enddo



if (id==0) then
	call reading1b
endif



call MPI_BCAST(datanokids,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(datapart,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(datapartkids1,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(datamediandelta,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(dataggap,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(dataoleta1,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(dataoleta2,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(datapartkids2 ,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(page1,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(page2,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(meanwage,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(meanearn,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)


!3 --------- Read in randnos and broadcast to to all
!   first allocate memory to store random numbers
allocate (randnos1(nt*nosims), randexp(nt*nosims), randupdate(nt*nosims),Iupdate(nosims,40), stat=randier)
if (randier.ne.0) write (*,*) 'error in allocating to randnos '

        open (unit=77, file ='../Inteninps/randnos.inp')  
        !file randnos.inp contains nt*nosims*5 random numbers
                                               
        do ii=1,nosims*nt-4,5
            read (77,9299) (randnos1(ii+jj1),jj1=0,4)
        enddo
        do ii=nosims*nt+1,nosims*nt*2-4,5
            read (77,9299) (randexp(ii+jj1-nosims*nt),jj1=0,4)
        enddo
        close(77)
    
        open(unit=777, file ='../Inteninps/randnosupdate.inp')
        do ii=1,nosims*nt
            read(777,*)randupdate(ii)
        enddo
        do ii=1,nosims
            do t=1,40
            !find out in which quarter hhold wnode and pnode is going to be updated
            rannum=randupdate(t+(ii-1)*nt)
            if(rannum.lt.0.25d0)then
                Iupdate(ii,t)=1
            elseif(rannum.ge.0.25d0.and.rannum.lt.0.5d0)then
                Iupdate(ii,t)=2
            elseif(rannum.ge.0.5d0.and.rannum.lt.0.75d0)then
                Iupdate(ii,t)=3
            else
                Iupdate(ii,t)=4
            endif
        enddo;enddo
        close(777)

	
	9299 format (5E16.8)	 



!4 --------- Read in wages and broadcast to to all
allocate(prob(nw,pnw,nw,pnw,nt),xww(nw,nt), pxw2(pnw,nt), pxw3(pnw,nt),pxw(pnw,nt),probF(nw,nw,nt), stat=randier)
allocate(probA(nw,pnw,nw,pnw,40),xwwA(nw,40), pxw2A(pnw,40))
if (randier.ne.0) write (*,*) 'error in allocating to wages '





if(quarter==0)then
    open(333,file='../Inteninps/wagepoints1812p_f.inp')
    open(335,file='../Inteninps/wagepoints1812p_m.inp')
else
    open(333,file='../Inteninps/wagepoints1812p_fQh.inp')
    open(335,file='../Inteninps/wagepoints1812p_mQh.inp')
	
endif
    do w=1,pnw
    do t=1,nt
	    read(335,3346)pxw2(w,t)
	   
    enddo
	
	enddo
    
    do w=1,nw
    do t=1,nt
	    read(333,3346)xww(w,t)
	    
    enddo
	enddo
    
    close(333)
    close(335)


3346 format (e17.8)





if(quarter==0)then
	open(334,file='../Inteninps/transwagepoints1812p.inp')
else
    open(334,file='../Inteninps/transwagepoints1812pQh.inp')
endif
	do t=1,nt
	do w=1,nw
	do p=1,pnw
	do ww=1,nw
	do pp=1,pnw
		read(334,3349)prob(ww,pp,w,p,t)
	enddo;enddo;enddo;enddo;enddo
	close(334)
3349 format (e17.8)





!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!LOOP 1!!
cont=0
!1-loop for period in which wage is different from the baseline (in baseline j_grid=1,1)
!(i)-to input an expected wage variation at j_grid and calculate the frisch
!(ii)-to calculate baseline economy with boom or bust at j_grid

do j_grid=1,1  !13,136 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!   
      cont=cont+1
      if (cont.eq.1) then 
        firstcall = 1
      else
        firstcall = 0
      endif
	 
	if(Icycle.gt.0)then
		age_cycle=(j_grid-1)/4 + 1  !this is the age at which j_grid period belongs
		q=j_grid-(age_cycle-1)*4  !this is the number of the quarter of the age
	else
		age_cycle=0
		q=0
	endif

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!LOOP 2!!
!2-loop for the size of wagevar to calculate the frisch,BASELINES: ingrid2=1,ngrid2=1
ingrid2=1  
ngrid2 =1  
do j_grid2=ingrid2,ngrid2   !loop for the size of the variation in wage
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 
         if(j_grid2.gt.1)then
			if(j_grid2==2)wagevar=1.01d0
			if(j_grid2==3)wagevar=1.05d0
			if(j_grid2==4)wagevar=1.10d0
			
			!frischt = j_grid
		else
			wagevar=1.d0
            !frischt=0
		
		endif
		
		!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		!!LOOP 3!!
		!3-loop for the period in which the frisch is calculated (it can be at same age as the recession/boom (j_grid) or in coming periods)
		!in baseline economies (in which j_grid2=1) set it =0
		startfrisch=0 !baseline=0, same age at recession/boom=j_grid, coming periods=j_grid
		endfrisch=0 !136 !136  !baseline=0, same age at recession/boom=j_grid, coming periods=124
		
		do j_frisch=startfrisch,endfrisch
		!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

			frischt=j_frisch
			
			

			
			if(frischt.lt.100)then
				write(name1,'(I2)'),frischt
			else
				write(name1,'(I3)'),frischt	
			endif
			write(name2,'(I1)'),j_grid2
			write(name3,'(I1)'),Icycle
			edad=age_cycle+21
			write(name4,'(I2)'),edad
			write(name5,'(I1)'),q
			
					
			if (id==0) then
			if(Icycle.eq.0)then
			   if(j_grid2.eq.1)then
					open(unit=20, file ='../Outputs/sims000'//trim(name3)//'.out') 
					open(unit=44, file ='../Outputs/sample000'//trim(name3)//'.out')
				else
					open(unit=20, file ='../Outputs/sims'//trim(name1)//trim(name2)//trim(name3)//'.out') 
					open(unit=44, file ='../Outputs/sample'//trim(name1)//trim(name2)//trim(name3)//'.out')
				endif
				!
			else
				if(j_grid2.eq.1)then
					open(unit=20, file ='../Outputs/sims'//trim(name4)//trim(name3)//'.out') 
					open(unit=44, file ='../Outputs/sample'//trim(name4)//trim(name3)//'.out')
				else
				
					if(startfrisch.eq.endfrisch)then
						open(unit=20, file ='../Outputs/sims'//trim(name4)//trim(name5)//trim(name2)//trim(name3)//'.out') 
						open(unit=44, file ='../Outputs/sample'//trim(name4)//trim(name5)//trim(name2)//trim(name3)//'.out')
					else
						open(unit=20, file ='../Outputs/sims'//trim(name4)//trim(name2)//trim(name3)//trim(name1)//'.out') 
						open(unit=44, file ='../Outputs/sample'//trim(name4)//trim(name2)//trim(name3)//trim(name1)//'.out')
					endif
				endif

			endif
				
			
             
	        open(45, RECL=2000,file='../Outputs/MRS.out',status='unknown')	     
            open(unit=1111, file ='../Outputs/gridsearch.out') 
            
        endif

   
	
	    PARGUESS(1)=guess(1) 
		PARGUESS(2)=guess(2) 
		PARGUESS(3)=guess(3) 
		PARGUESS(4)=guess(4) 
		PARGUESS(5)=guess(5) 
		PARGUESS(6)=guess(6) 
		PARGUESS(7)=guess(7) 
		PARGUESS(8)=guess(8) 
		PARGUESS(9)=guess(9) 
        PARGUESS(10)=guess(10)
	    PARGUESS(11)=guess(11)
		PARGUESS(12)=guess(12)
		PARGUESS(13)=guess(13)
		

		call partner(parguess,targetst,numtargets)
		
		close(20)
		close(44)
		close(45)
       
		
    enddo !end loop over j_frisch
enddo  !end loop over j_grid
enddo  !end loop over j_grid2



end subroutine calibrate

