
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!



module consolve

!here we back out consumption in the simulations by using the 
!envelope theorem and the interpolation routine for the derivative
!of the value function

use params
use subrout
use assetgrid

implicit none

double precision maxinc, valstore

contains

!______________________________________________________________________	

	subroutine consumpt( stat, cons, leis, nodeas, nodebit)

	double precision cons, estim1, estim4, &
			intxet, intaet, leis
	integer mina, node, nodeas, nodebit, stat

	if (stat.gt.0) then 
				  
		call find(age, partcash, nodeas, mina, intaet, intxet, stat)
		node   = nodebit + mina   

		visitemp(age,mina) = visitemp(age,mina) + 1
		
		estim1   = withemploy(node,age)     
		estim4   = withemploy(node+1, age)  
		cons	 = (intaet*estim1 + intxet*estim4)

		estim1   = leisemploy(node,age)     
		estim4   = leisemploy(node+1, age)  
		leis	 = (intaet*estim1 + intxet*estim4)
		
		
	else

		call find(age, partcash, nodeas, mina, intaet, intxet, stat)
		node   = nodebit + mina   !if not working then alpha is irrelevant

		visitnon(age,mina) = visitnon(age,mina) + 1
		
		estim1   = withun(node,age)     
		estim4   = withun(node+1, age)  
		cons	 = intaet*estim1 + intxet*estim4

        leis = hours
		
		
	endif

	end subroutine consumpt




end module consolve

