!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine calibrate
use inputs
use statistics
use params
implicit none
double precision::  rannum, time1, time2 !,guess(numtargets)

INTEGER::cont,var(numtargets),randier, ii, jj1, w, p, ww, pp, t, q, edad

character*1::name3


external partner

open (unit=10,  file ='../Outputs/dump.out')             
open (unit=12, RECL=2000,file ='../Outputs/dump2.out')             


!1--------READ PARAMETER VALUES TO NODE 1 AND BROADCAST TO THE OTHER NODES
if (id==0) then
	call reading1
endif

 
call MPI_BCAST(quarter,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(nt,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(ret,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(na,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(nw,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(noexp,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(lown,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(uppn,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(maxit,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(pnw,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(nosims,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(minass,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(xtol,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(maxim,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(growth,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(upper,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(nu,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(detrr,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(meandisc,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(disc,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(variance,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(pvariance,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(corrho,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)

call MPI_BCAST(inithk,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(hours,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(hoursfix,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(minhours,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(nokids,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(kid_1,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(kid_2,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(kid_3,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(kid_4,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(kid_5,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(kid_6,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(kid_7,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(kid_8,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(kid_9,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(propkid_1,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(propkid_2,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(propkid_3,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(propkid_4,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(propkid_5,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(propkid_6,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(propkid_7,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(propkid_8,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(propkid_9,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(alfaL,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(alfaM,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(alfaH,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(mm,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(ssi,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(fullfrac,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(edu,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(chcostfunc1,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(chcostfunc2,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(chcostfunc3,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(chcostfunc4,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(chcostfunc5,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(chcostfunc6,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(chcostfunc7,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(chcostfunc8,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(borrowdum,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(Icycle,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(Isample,1,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(marsvarwage,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(lump,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)


call MPI_BCAST(coef0,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(coefage1,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(coefage2,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(coefage3,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(coefage4,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(coefchild1,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(coefchild2,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(coefchild3,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(coefsize,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(coefhaskid,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(coefc,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(coefnc,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)

call MPI_BCAST(hourseis,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)


kid=(/kid_1,kid_2,kid_3,kid_4,kid_5,kid_6,kid_7,kid_8,kid_9/)
propkid=(/propkid_1,propkid_2,propkid_3,propkid_4,propkid_5,propkid_6,propkid_7,propkid_8,propkid_9/)
chcostfunc=(/chcostfunc1,chcostfunc2,chcostfunc3,chcostfunc4,chcostfunc5,chcostfunc6,chcostfunc7,chcostfunc8/)


!2--------READ GUESS FOR PARAMETER VALUES TO NODE 1 AND BROADCAST TO THE OTHER NODES
if(id==0)then
	if(edu.eq.0)then
		open(unit=999, file ='../Inteninps/mpiguess.inp')
	elseif(edu.eq.1)then
		open(unit=999, file ='../Inteninps/mpiguessNC.inp')
	else
		open(unit=999, file ='../Inteninps/mpiguessC.inp')
	endif
	do cont=1,numtargets
		read (999,*) guess(cont)
		
	enddo
	close(999)
endif


if(ID==0)write(*,*)numtargets
do cont=1,numtargets
	call MPI_BCAST(guess(cont),1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
	if(ID==0)write(*,*)cont,guess(cont)
enddo



if (id==0) then
	call reading1b
endif



call MPI_BCAST(datanokids,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(datapart,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(datapartkids1,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(datamediandelta,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(dataggap,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(dataoleta1,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(dataoleta2,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(datapartkids2 ,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(page1,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(page2,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(meanwage,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)
call MPI_BCAST(meanearn,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,ierr)


!3 --------- Read in randnos and broadcast to to all
!   first allocate memory to store random numbers
allocate (randnos1(nt*nosims), randexp(nt*nosims), randupdate(nt*nosims),Iupdate(nosims,40), stat=randier)
if (randier.ne.0) write (*,*) 'error in allocating to randnos '

        open (unit=77, file ='../Inteninps/randnos.inp')  
        !file randnos.inp contains nt*nosims*5 random numbers
                                               
        do ii=1,nosims*nt-4,5
            read (77,9299) (randnos1(ii+jj1),jj1=0,4)
        enddo
        do ii=nosims*nt+1,nosims*nt*2-4,5
            read (77,9299) (randexp(ii+jj1-nosims*nt),jj1=0,4)
        enddo
        close(77)
    
        open(unit=777, file ='../Inteninps/randnosupdate.inp')
        do ii=1,nosims*nt
            read(777,*)randupdate(ii)
        enddo
        do ii=1,nosims
            do t=1,40
            !find out in which quarter hhold wnode and pnode is going to be updated
            rannum=randupdate(t+(ii-1)*nt)
            if(rannum.lt.0.25d0)then
                Iupdate(ii,t)=1
            elseif(rannum.ge.0.25d0.and.rannum.lt.0.5d0)then
                Iupdate(ii,t)=2
            elseif(rannum.ge.0.5d0.and.rannum.lt.0.75d0)then
                Iupdate(ii,t)=3
            else
                Iupdate(ii,t)=4
            endif
        enddo;enddo
        close(777)
!        
!        open(unit=7777, file ='../Inteninps/randnosexp.inp')
!        do ii=1,nosims*nt
!            read(7777,*)randexp(ii)
!        enddo
!        close(7777)
	
	9299 format (5E16.8)	 



!4 --------- Read in wages and broadcast to to all
allocate(prob(nw,pnw,nw,pnw,nt),xww(nw,nt), pxw2(pnw,nt), pxw3(pnw,nt),pxw(pnw,nt),probF(nw,nw,nt), stat=randier)
allocate(probA(nw,pnw,nw,pnw,40),xwwA(nw,40), pxw2A(pnw,40))
if (randier.ne.0) write (*,*) 'error in allocating to wages '





if(quarter==0)then
    open(333,file='../Inteninps/wagepoints1812p_f.inp')
    open(335,file='../Inteninps/wagepoints1812p_m.inp')
else
    open(333,file='../Inteninps/wagepoints1812p_fQh.inp')
    open(335,file='../Inteninps/wagepoints1812p_mQh.inp')
	
endif
    do w=1,pnw
    do t=1,nt
	    read(335,3346)pxw2(w,t)
	   
    enddo
	
	enddo
    
    do w=1,nw
    do t=1,nt
	    read(333,3346)xww(w,t)
	    
    enddo
	enddo
    
    close(333)
    close(335)


3346 format (e17.8)





if(quarter==0)then
	open(334,file='../Inteninps/transwagepoints1812p.inp')
else
    open(334,file='../Inteninps/transwagepoints1812pQh.inp')
endif
	do t=1,nt
	do w=1,nw
	do p=1,pnw
	do ww=1,nw
	do pp=1,pnw
		read(334,3349)prob(ww,pp,w,p,t)
	enddo;enddo;enddo;enddo;enddo
	close(334)
3349 format (e17.8)


!    do t=1,nt
!	do w=1,nw
!	do p=1,pnw
!	do ww=1,nw
!	do pp=1,pnw
!		prob(ww,pp,w,p,t)=probA(ww,pp,w,p,t)
!	enddo;enddo;enddo;enddo;enddo
!	
!	 do w=1,pnw
!    do t=1,nt
!	   pxw2(w,t)=pxw2A(w,t)
!	   
!    enddo;enddo
!    
!    do w=1,nw
!    do t=1,nt
!	    xww(w,t)=xwwA(w,t)
!	    
!    enddo;enddo

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!HUSBAND EARNINGS IF THERE IS NOT UNCERTAINTY!!
!!if(noUncHus==1)then
!!!no uncertainty on husband earnings, but we have heterogeneity: earnings corresponding to period t=15
!!
!!do t=1,nt
!!    pxw2(:,t)=pxw2(:,(1-quarter)*10+quarter*40)
!!enddo
!!
!!do t=1,nt
!!do ww=1,nw
!!do w=1,nw
!!    probF(ww,w,t)=0.d0
!!do pp=1,pnw
!!do p=1,pnw
!!	probF(ww,w,t)=probF(ww,w,t) + prob(ww,pp,w,p,t)/dble(nw)
!!enddo
!!enddo
!!enddo
!!enddo
!!enddo
!!
!!
!!prob=0.d0
!!do t=1,nt
!!do ww=1,nw
!!do w=1,nw
!!do pp=1,pnw
!!    prob(ww,pp,w,pp,t)=probF(ww,w,t)
!!enddo
!!enddo
!!enddo
!!enddo
!!
!!elseif(noUncHus==2)then
!!!here we remove all the uncertainty but we have heterogeneity in husband earnings and wages
!!
!!do t=1,nt
!!    pxw2(:,t)   = pxw2(:,(1-quarter)*10+quarter*40)
!!    xw(:,t)     = xw(:,(1-quarter)*10+quarter*40)
!!enddo
!!
!!prob=0.d0
!!do t=1,nt
!!do ww=1,nw
!!do pp=1,pnw
!!    prob(ww,pp,ww,pp,t)=1.d0
!!enddo
!!enddo
!!enddo
!!
!!endif




do ihicks=0,1

!if (ihicks.eq.0) then 
   firstcall = 1
!else
!   firstcall = 0
!endif


!set to the baseline case parameters that compute different counterfactuals in the basic code
!j_grid
age_cycle=0
q=0
!j_grid2
wagevar=1.d0
!j_frisch
frischt=0
     

	 


write(name3,'(I1)'),ihicks
			
open(unit=20, file ='../Outputs/sims000'//trim(name3)//'.out') 
open(unit=44, file ='../Outputs/sample000'//trim(name3)//'.out')
			
open(45, RECL=2000,file='../Outputs/MRS.out',status='unknown')	     
open(unit=1111, file ='../Outputs/gridsearch.out') 
            


   
	
PARGUESS(1)=guess(1) 
PARGUESS(2)=guess(2) 
PARGUESS(3)=guess(3) 
PARGUESS(4)=guess(4) 
PARGUESS(5)=guess(5) 
PARGUESS(6)=guess(6) 
PARGUESS(7)=guess(7) 
PARGUESS(8)=guess(8) 
PARGUESS(9)=guess(9) 
PARGUESS(10)=guess(10)
PARGUESS(11)=guess(11)
PARGUESS(12)=guess(12)
PARGUESS(13)=guess(13)
		

call partner(parguess,targetst,numtargets)
		
close(20)
close(44)
close(45)
       
		


enddo !end loop over ihicks

end subroutine calibrate

