
clear matrix
clear
set more off
capture log close
set mem 200m

*`j3': SCENARIO(0-NORMAL TIMES,1-RECESSION OR 2-BOOM)
*`j2': SIZE OF WAGE CHANGE (2 (1%),3 (5%), 4 (10%))


forval j2=4/4{
use C:\PROYECTOS\FRISCH\OutputsNR\frisch\baseline\elast`j2'0


gen quarter=t-(age-22)*4
gen cycle=0



append using elast`j2'1


append using C:\PROYECTOS\FRISCH\OutputsNR\frisch\boom\elast`j2'2






gen edad=age+(t-(age-22)*4)/4

gen ageg=1 if edad>=25 & edad<30
replace ageg=2 if edad>=30 & edad<35
replace ageg=3 if edad>=35 & edad<40
replace ageg=4 if edad>=40 & edad<45
replace ageg=5 if edad>=45 & edad<50
replace ageg=6 if edad>=50 & edad<55

gen ciclo=1 if cycle==1
replace ciclo=2 if cycle==0
replace ciclo=3 if cycle==2

log using cycle-elast.log,replace



****EXTENSIVE

display "Extensive"

table ciclo,c(mean e)
table q if cycle==1,c(mean e)




****INTENSIVE-h50
display " Intensive, average of median"

table ciclo,c(mean h50)
table q if cycle==1,c(mean h50)



****MACRO
display "Macro"

table ciclo,c(mean m mean eff)
table q if cycle==1,c(mean m mean eff)

log close



*end