!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


module assetgrid 
      use inputs
	  use params 
	  use wageproc 
	  use subrout
	  


use inputs

 
	  implicit none 
 
	  double precision, private :: const, deviate, devmen, experto, inimax,inipar, lower, & 
	  maxdummy, meandif, nconst, proport, upnew, workhigh
 
	  integer, private :: i, ind, ind1, jl, jm, ju, p, t , x, xmin, xtob, xtonon 
	  contains  
 
	  subroutine bounds 
 
			!asset grid is now grid for cash excluding wage 
 
			mininc(1,nt+ret)	= 0.d0 
			 
			do t=nt+ret,1,-1 
			
			 if (t.le.nt) then 
			    do x=1,noexp
			 
				    if (borrowdum.eq.0) then  !borrowing is allowed

     
                            
                              if(t.eq.1)then
                                alow(x,t)= pxw(pnw,t)  
                              else
					             alow(x,t) = -max(mininc(max(x-1,1),t), mininc(x,t) + &  
			 	             xw(nw,t)*expvalue(x,t)*hoursfix-fixed(t)) + minass 
								 
							
    			   			  endif        
             
				    elseif (borrowdum.ge.1) then !no borrowing (note structure of prog has xa being 
											!cash, so this is not a point due to partner income
					    alow(x,t) = pxw(pnw,t)

				    endif
				 
			    enddo
			 
			    do x=1,noexp
				    if (borrowdum.eq.0) then 

					    if (t.ge.2) mininc(x,t-1)	= (- alow(x,t) + pxw(pnw,t) )/detrr 
                                                    
				    elseif (borrowdum.ge.1) then !no borrowing
					    if (t.ge.2) mininc(x,t-1) = 0.d0
				    endif
    				 
			    enddo
		
    		else
    		
			    alow(1,t)       = pxw(pnw,nt) * ssi
                mininc(1,t-1)   = 0.d0
    		
    		endif
 
			enddo 
			
				 
            
            
			if (borrowdum.le.1) then !saving is unconstrained
				
				ahigh(1) = pxw(1,1)
				ahigh2(1) = (xw(1,1)*expvalue(noexp,1)*hoursfix-fixed(1) + ahigh(1)) 
				
			
				ind=(1-quarter)*30+quarter*100
				do t=2,nt
                
				if(t.lt.ind)then
		
					if(t.le.50)then  !0.1
					  ahigh(t) = ahigh2(t-1)*detrr + 0.3*pxw(1,t)
					  ahigh2(t) = (0.3*xw(1,t)*expvalue(noexp,t)*hoursfix-fixed(t) + ahigh(t)) 
					else
						ahigh(t) = ahigh2(t-1)*detrr + 0.7*pxw(1,t)
					  ahigh2(t) = (0.7*xw(1,t)*expvalue(noexp,t)*hoursfix-fixed(t) + ahigh(t)) 

					endif
 
				else
				    ahigh(t)=ahigh(t-1)
				    
	
				endif		
				
				enddo

				do t=nt+1,nt+ret
					    if(quarter==0)then
					        ahigh(t) = ahigh(t-1)*0.8d0
					    else
					        ahigh(t) = ahigh(t-1) *0.96d0 
					    endif
					
				enddo
	

			elseif (borrowdum.eq.2) then !saving is constrained
				ahigh(1) = max(pxw(1,1), 1.d0)
				do t=2,nt
					ahigh(t) = max(pxw(1,t) , 1.d0)
				enddo

			endif

          
            


 
	  end subroutine bounds 
 
	  subroutine grid(xval,nodeas, asage) 
 
	  integer asage, nodeas, xval
 
	! extra points very close to bottom ("lown" points) 
	! then large cluster in reasonable range, spread geometrically 
	! then some at high asset levels (above "upper"),  
	! spread out more, where solution is more linear ("uppn" points)  
								 
			 !first do employed bit 

 			 workhigh = max(alow(xval,asage)+0.1d0, min(asscut(nodeas,asage),ahigh(asage))) 
			if (workhigh.gt.1.d-1) then  
		     !xawork(1,nodeas, asage) = alowemp(xval,asage) 
		     xawork(1,nodeas, asage) = alow(xval,asage) 
		     xawork(2,nodeas, asage) = xawork(1,nodeas,asage) + 1.d-8 
			 xawork(3,nodeas,asage) = xawork(2,nodeas, asage) + 1.d-6 
		     xawork(4,nodeas,asage) = xawork(3,nodeas,asage) + 1.d-4 
		     xawork(5,nodeas,asage) = xawork(4,nodeas,asage) + 1.d-4 
		     xawork(6,nodeas,asage) = xawork(5,nodeas,asage) + 1.d-3 


			 lower = xawork(6,nodeas,asage) + (workhigh-xawork(6,nodeas,asage))*0.075d0

			 const = (lower - xawork(6,nodeas,asage))/dble(lown-6) 

			 do i=7,lown 
			   xawork(i,nodeas,asage) = xawork(6,nodeas,asage) + const*dble(i-6)  
		     enddo 
			 !const = (workhigh - lower)/dble(na-lown) 
			 !do i=lown+1,na 
			 !  xawork(i,nodeas,asage) = lower + const*dble(i-lown)  
			 !enddo		 

			!NEW COARSE PART
			upnew = xawork(lown,nodeas,asage) + (workhigh-xawork(lown,nodeas,asage))*0.25d0
			  
			 const = (upnew - lower)/dble(na-lown-uppn) 
			 do i=lown+1,na-uppn 
			   xawork(i,nodeas,asage) = lower + const*(i-lown)  
			 enddo	
			 const = (workhigh - upnew)/dble(uppn) 
			 
			 do i=na-uppn+1,na 
				  xawork(i,nodeas,asage) = upnew + const*(i-(na-uppn))  
			 enddo
			 
			 
			 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			 !const = (workhigh - xawork(6,nodeas,asage))/dble(na-6)
			 !do i=7,na
			 !  xawork(i,nodeas,asage) = xawork(6,nodeas,asage) + const*dble(i-6)  
		     !enddo 
			 
			 
			 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
	 	
		 else 
		     xawork(1,nodeas, asage) = alow(xval,asage)   
			 const = (workhigh - xawork(1,nodeas,asage))/dble(na-1)
			 do i=2,na 
			   xawork(i,nodeas,asage) = xawork(i-1,nodeas,asage) + const  
		     enddo 
		  endif


		   

	  end subroutine grid 
 
 
 !_________________________________________________________
 
	  subroutine gridnon(xval, nodeas,asage) 
 
	  integer asage, nodeas, nadum, lowndum, uppndum , xval
 
			nadum = na 
			lowndum = lown 
			uppndum = uppn 
			!maxdummy = max(ahigh(asage),asscut(nodeas,asage)+100.d0 )
			
			maxdummy = ahigh(asage)                             
			xanon(1,nodeas,asage) = min(max(alow(xval,asage),asscut(nodeas,asage) ),ahigh(asage))
			!xanon(1,nodeas,asage) = alow(xval,asage)
			if (xanon(1,nodeas,asage).ge.maxdummy) maxdummy = xanon(1,nodeas,asage) + 5.d0
			!!!
			xanon(2,nodeas,asage) = xanon(1,nodeas,asage) + 1.d-3 
			xanon(3,nodeas,asage) = xanon(2,nodeas,asage) + 1.d-2 

			lower = xanon(3,nodeas,asage) + (maxdummy - xanon(3,nodeas,asage))*0.075d0


			 const = (lower - xanon(3,nodeas,asage))/dble(lowndum-3) 

			 do i=4,lowndum 
			   xanon(i,nodeas,asage) = xanon(3,nodeas,asage) + const*(i-3)  
		     enddo 

			upnew = xanon(lowndum,nodeas,asage) + (maxdummy - xanon(lowndum,nodeas,asage))*0.25d0
			  
			 const = (upnew - lower)/dble(nadum-lowndum-uppndum) 
			 do i=lowndum+1,nadum-uppndum 
			   xanon(i,nodeas,asage) = lower + const*(i-lowndum)  
			 enddo						    


			 const = (maxdummy- upnew)/dble(uppndum) 
			 do i=nadum-uppndum+1,nadum 
				  xanon(i,nodeas,asage) = upnew + const*(i-(nadum-uppndum))  
			 enddo		 
 
		end subroutine gridnon		      
 
end module assetgrid 

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
