!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module params

use inputs
use subrout
!USE nag_nlp
!USE nag_error_handling

implicit none

integer,parameter::npar=13, nstats=13

integer ageyoungest, notypes, year, years1, years2, size, haskid,flag
parameter (notypes=9)
integer kid(notypes),kid_1,kid_2,kid_3,kid_4,kid_5,kid_6,kid_7,kid_8,kid_9, ntotal, ntotal2, hoursdecision,quarter
double precision propkid(notypes)
double precision chcostfunc1,chcostfunc2,chcostfunc3,chcostfunc4,chcostfunc5,chcostfunc6,chcostfunc7,chcostfunc8

!TYPE (nag_error) :: error
!type (nag_nlp_cntrl_dp):: control


double precision,dimension(npar)::fpar,caliweig
integer:: imodel, icont,nmindex(3),sindex(3),nmindex2(4),sindex2(4)

double precision::modpars(npar), statdat(npar),guess(npar), parguess(npar),targetst(npar)



integer begnosims, bestiter, borrowdum, edu, endobs, individ,  lown, maxit, maxnod, & 
		maxntinp, method, na, noalpha, no, nt, ret,noparams,  noviolations, nononviolations,  &
		noexp, nonodes, nonodes2, nosims, nw, pnw, startobs, tobs,totlen, uppn, &
        nonotyet, nonever,  max_fun_eval, wrunit 
		

double precision alpha1, alfaL, alfaM, alfaH, age1, age2, kidalpha, conbit, bitend, bitend2, bitwork, cpow,&
	 besterror,  chcostfunc(8), conk,  consprop, & 
childcost, costworking, corrho, deltaper0, deltaper1, deltatr, deltatr1, detrr, disc, endbit, endbit1, endbit2, &
fullfrac, gendergap, growth, hours,  hoursfix, hourseis,  inithk, inilow, inihigh, iniggap, & 
invnu, kidalpha0, lowmult, highmult, kk, mm,  nu1eta1, nu1eta11, &
maxim,  minhours, &
meanwage, meanearn, meandisc, mediandelta, minass, mu, nokids, nu, nu1, &
oleta0,oleta1,oleta1i,&
page1, page2, partkid, partkid1, partkid2, partkid1elas, partkid2elas, partbef, p3to18,  &
partaft, partnomot, pvariance, ratiopartborn, simbit, & 
ssi, trstd, xtol, upper, utpart, variance, bbounds(npar,2), &
propkid_1,propkid_2,propkid_3,propkid_4,propkid_5,propkid_6,propkid_7,propkid_8,propkid_9,  partnever, partnotyet, oldpar(2), oldparone, &
chi,chi1,phi,phi1,theta,theta1,alfa,alfa1,alfa11,&
coef0, coefchild1, coefchild2, coefchild3, coefsize, coefage1, coefage2, coefage3, coefage4, coefhaskid, coefc, coefnc



double precision datanokids, datapart, datapartkids, datapartkids1, datapartkids2, datamediandelta, dataggap, & 
        dataoleta1, dataoleta2, data3to18, datahours, negnu, eps,eps1, utnorm, rel_tol, abs_tol


character*80 dummyinp

integer agekid, agekid2, indic, frischt, Icycle, Isample, output, solut, weignosims

double precision:: wagevar

double precision, allocatable :: ahigh(:), ahigh2(:), alow(:,:), asscut(:, :), mininc(:,:)
double precision, allocatable :: alowemp(:,:), alownon(:,:)                     
double precision, allocatable :: xanon(:,:,:),xawork(:,:,:), valemploy(:,:), leisemploy(:,:)
double precision, allocatable :: valun(:,:), equival(:)      
double precision, allocatable :: withemploy(:,:), withun(:,:), infants(:), fixed(:)
double precision, allocatable :: calibstats(:), calibparams(:)
double precision, allocatable :: randnos1(:), randexp(:), randupdate(:), prob(:,:,:,:,:), pxw(:,:), &
&pxw2(:,:),pxw3(:,:), xww(:,:),probF(:,:,:),probA(:,:,:,:,:),xwwA(:,:), pxw2A(:,:)
double precision, allocatable :: payfr(:,:,:), payhighf(:,:,:), paylowf(:,:,:),maxpartcash(:)


double precision, allocatable :: alfad(:),alfa1d(:),alfa11d(:),alfadaux(:)


double precision, parameter		:: pi = 3.141592653589793d0 

integer, parameter						:: nostat = 2
integer, private							:: i, t

integer, allocatable :: visitemp(:,:), visitnon(:,:), visitexpvalue (:,:),&
&countcornerUmin(:,:),countcornerUmax(:,:),countcornerEmin(:,:),countcornerEmax(:,:)
integer, allocatable :: frpart(:,:,:), frparthighw(:,:,:), counthighw(:,:,:), frpartloww(:,:,:), countloww(:,:,:), &
                        countall(:,:,:) ,avhour(:,:,:),countallhour(:,:,:),payhour(:,:,:),Iupdate(:,:)

double precision, allocatable ::  utiBASELINE(:),  uti(:) 

character*7::namest(nstats),namepar(npar)


contains




subroutine reading1

	implicit none
	integer	:: ier(2)

	open (unit=9, file='../Inteninps/mpiparams.inp', status='old', err=900)
		read (9,*) quarter
	    read (9,*) nt		!1				number of periods of work
 	    read (9,*) ret		!2				number of periods of retirement
	    read (9,*) na		!3				number of grid points in (conditional) cash-in-hand state
	    read (9,*) nw		!5
	    read (9,*) noexp	!6       max number of years experience
	    read (9,*) lown		!7			used in making cash grid finer at low cash levels
	    read (9,*) uppn		!8			used in making cash grid more coarse at high cash levels
	    read (9,*) maxit	!9			number of iterations in trying to solve
	    read (9,*) pnw		!11
	    read (9,*) nosims	!15			total number of simulations = nosims
	    read (9,*) minass 		!8		(machine zero issue)
	    read (9,*) xtol   		!9    (machine zero issue)
	    read (9,*) maxim  		!10		defining upper bound on cash grid
	    read (9,*) growth 		!11   defining upper bound on cash grid
	    read (9,*) upper  		!12 upper will be chosen by the resass number
	    read (9,*) nu    	!1	risk aversion
	    read (9,*) detrr    	!4	constant interest rate 
	    read (9,*) meandisc 	!5	constant discount ratE
	    read (9,*) variance		!15 variance of permanent productivity shock
	    read (9,*) pvariance   	!18 variance of primary earner perm prod shocks
	    read (9,*) corrho       ! correlation coefficient bet permanent shocks					 
	    read (9,*) inithk			!35
		read (9,*) hours    	!3	total hours available each period
	    read (9,*) hoursfix			!38
		read (9,*) minhours
	    read (9,*) nokids			!44
	    read (9,*) kid_1
	    read (9,*) kid_2
	    read (9,*) kid_3
		read (9,*) kid_4
	    read (9,*) kid_5
	    read (9,*) kid_6
		read (9,*) kid_7
	    read (9,*) kid_8
	    read (9,*) kid_9
		read (9,*) propkid_1
	    read (9,*) propkid_2
	    read (9,*) propkid_3
		read (9,*) propkid_4
	    read (9,*) propkid_5
	    read (9,*) propkid_6
		read (9,*) propkid_7
	    read (9,*) propkid_8
	    read (9,*) propkid_9
		read (9,*) alfaL
		read (9,*) alfaM
		read (9,*) alfaH
	    read (9,*) mm
	    read (9,*) ssi
	    read (9,*) fullfrac
        read (9,*) edu
	    read (9,*) chcostfunc1
	    read (9,*) chcostfunc2
	    read (9,*) chcostfunc3
	    read (9,*) chcostfunc4
	    read (9,*) chcostfunc5
	    read (9,*) chcostfunc6
	    read (9,*) chcostfunc7
	    read (9,*) chcostfunc8
        read (9,*) borrowdum
		read (9,*) Icycle
		read (9,*) Isample
		
	
		
        								
	close (9) 
	
	disc     = 1.d0 / meandisc
	
	if(quarter==1)then
	        nt         = nt*4
	        ret        = ret*4 
	        
	        disc       = disc**0.25d0
		    detrr      = detrr**0.25d0
		  
	        	        
	        hours      = hours*0.25d0
	        hoursfix   = hoursfix*0.25d0   
	         
	endif
	hourseis   = hours - hoursfix

		
    
    open (unit=19, file='../Inteninps/coef.inp', status='old', err=900)

        read (19,*) coef0
        read (19,*) coefage1
        read (19,*) coefage2
        read (19,*) coefage3
		read (19,*) coefage4
        read (19,*) coefchild1
        read (19,*) coefchild2
        read (19,*) coefchild3
        read (19,*) coefsize
		read (19,*) coefhaskid
		read (19,*) coefnc
		read (19,*) coefc
		

    close (19) 
    
    

 900     continue
!		write (*,*) 'error opening params.inp '


end subroutine reading1


subroutine reading1b

	implicit none
	integer	:: ier(2)
	
	if(edu.eq.0)then
		open (unit=9, file='../Inteninps/targets.inp', status='old')
	elseif(edu.eq.1)then
		open (unit=9, file='../Inteninps/targetsNC.inp', status='old')
	else
		open (unit=9, file='../Inteninps/targetsC.inp', status='old')
	endif
	

        read (9,*) datanokids
        read (9,*) datapart			
        read (9,*) datapartkids		
        read (9,*) datamediandelta
        read (9,*) dataggap
        read (9,*) dataoleta1
        read (9,*) dataoleta2
        read (9,*) data3to18
        read (9,*) datapartkids1 
        read (9,*) datapartkids2
        read (9,*) datahours
		read (9,*) page1		!25 earnings growth for husband
	    read (9,*) page2		!26		
		read (9,*) meanwage		!23 mean wage for second earner
	    read (9,*) meanearn		!24 mean earnings for husband			
		

    close (9) 
	
	
	
	
end subroutine reading1b
	
subroutine reading2( iret )
	
	implicit none
	integer, intent(out)	:: iret
	integer	:: ier(2)

	nonodes		= pnw*na*nw*noexp
	nonodes2    = pnw*nw*noexp
	maxntinp    = nt
	no			= 1
	totlen		= maxntinp + ret
	
	ntotal = pnw*nw*noexp
	ntotal2 = pnw*nw*noexp*na
    
    
            
    nmindex = (/nw,pnw,noexp/)
    nmindex2 = (/nw,pnw,noexp,na/)

     eps = 0.99d0 
     eps1 = 1.01d0

     
	!ALLOCATE ARRAYS

	allocate ( ahigh(totlen), ahigh2(totlen), alow(noexp,totlen), asscut(nonodes2,totlen),maxpartcash(nt+ret),	&
		    xanon(na,nonodes2,totlen), xawork(na,nonodes2,totlen), &
		    alowemp(noexp,totlen), alownon(noexp,totlen),           &  
			valemploy(nonodes,totlen), valun(nonodes,totlen), leisemploy(nonodes,totlen), &
			withemploy(nonodes,totlen), withun(nonodes,totlen), mininc(noexp,totlen), &
			equival(totlen), infants(totlen), fixed(maxntinp), &
            calibparams(npar), calibstats(npar),  & 
			payfr(3,noexp, 2), payhighf(3,noexp, 2), paylowf(3,noexp, 2), & 
			alfad(totlen),alfa1d(totlen),alfa11d(totlen),alfadaux(totlen), &
			stat = ier(1) )


	allocate ( visitnon(totlen,na), visitemp(totlen,na), visitexpvalue(totlen,noexp), countall(3,noexp,2), & 
	countcornerUmin(3,totlen),countcornerUmax(3,totlen),countcornerEmin(3,totlen),countcornerEmax(3,totlen),&
			frpart(3,noexp, 2), frparthighw(3,noexp,2), counthighw(3,noexp,2), frpartloww(3,noexp,2), countloww(3,noexp,2), & 
            avhour(3,noexp,2),countallhour(3,noexp,2),payhour(3,noexp,2),	stat = ier(2) )

	do i=1,2
		if ( ier(i).ne.0) then 
			iret = ier(i)
			return
		endif
	enddo

	iret = 0

	return

171 format (a80)

!900 continue
!		write (*,*) 'error opening params.inp '
		return

end subroutine reading2




subroutine modpar


        hoursdecision=1
        
        if(quarter==0)then
		    startobs=1  
            endobs=nt 
            tobs=nt 
        else
		!from age 25 to 55 (note model starts at 22)
            startobs=13 
            endobs=136
            tobs=124 
        endif

		agekid2=agekid  + (1-quarter)*2+quarter*8  !second child
		
		infants=0.d0
		
		
			
			
			
		do t=1,totlen
		    if(quarter.eq.0)then
		        year=t               !age of hhold 
		        
		        years1=t-agekid   !age of first child
		        years2=t-agekid2  !age of second child
		  
		    else
		        year=(t-1)/4 + 1
		        years1=(t-1)/4  - (agekid-1)/4 
                years2=(t-1)/4  - (agekid2-1)/4 
		    endif



			!alpha is adjusted here to account for demographics
        !!alfadaux=coef0  !this is just the constant in the MRS regression
        alfadaux=alfa   !we calibrate this
		
		

            !1-age 
            alfadaux(t)=alfadaux(t)    + coefage1*dble(year + 22)     &
                                     & + coefage2*(dble(year + 22)**2.d0) &
                                     & + coefage3*(dble(year + 22)**3.d0)/1000.d0 &
									& + coefage4*(dble(year + 22)**4.d0) /10000.d0
			
			


            !2-number of children in each age group
			
            if(years1.ge.0.and.years1.lt.3)then
                alfadaux(t)=alfadaux(t) + coefchild1
            elseif(years1.ge.3.and.years1.lt.16)then
                alfadaux(t)=alfadaux(t) + coefchild2
            elseif(years1.ge.16.and.years1.lt.19)then
                alfadaux(t)=alfadaux(t) + coefchild3
            endif

            if(years2.ge.0.and.years2.lt.3)then
                alfadaux(t)=alfadaux(t) + coefchild1
            elseif(years2.ge.3.and.years2.lt.16)then
                alfadaux(t)=alfadaux(t) + coefchild2
            elseif(years2.ge.16.and.years2.lt.19)then
                alfadaux(t)=alfadaux(t) + coefchild3
            endif
		

			
			
            !3-family size & haskid
            size=2
			haskid=0
            if(years1.ge.0.and.years1.lt.19)then
                size=size + 1
				haskid=1
            endif
            if(years2.ge.0.and.years2.lt.19)then
                size=size + 1
				haskid=1
            endif
			alfadaux(t)=alfadaux(t) + coefsize*log(dble(size)) +  coefhaskid*dble(haskid)
			
			!4-education
			if(edu.eq.1)then
				alfadaux(t)=alfadaux(t) + coefnc
			elseif(edu.eq.2)then
				alfadaux(t)=alfadaux(t) + coefc
			endif
			
	
           alfad(t)=exp(alfadaux(t))  
		   
	


            
           phi1=1.d0/phi
		   theta1=1.d0/theta
    	   chi1=1.d0/chi  

 
            
            !cost of children if working
			if (t.ge.agekid.AND.t.le.agekid+(1-quarter)*7+quarter*32)then
               
	           infants(t) = kidalpha0*chcostfunc(years1 + 1 )/chcostfunc(1)
	        
	        endif
		
			
		   !equivalences of scale
		
            
            equival(t) = 1.d0

		enddo  !t
		
		alfad(nt+1:totlen)=alfad(nt)
		
		
        statdat(1)= datanokids  
        statdat(2)= datapart
        statdat(3)= datapartkids
		statdat(4)= datamediandelta
        statdat(5)= dataggap
        statdat(6)= dataoleta1
        statdat(7)= dataoleta2
        statdat(8)= data3to18
        statdat(9)= datapartkids1
        statdat(10)= datapartkids2
        statdat(11)= datahours
        
		
end subroutine modpar
!______________________________________________
double precision function utility(cons, leis, age)
	 
		double precision cons, leis, conse, aux,consN,leisN
		integer age, stat
 
		conse=cons/equival(age)
		
		consN=conse/13.d0
		leisN=leis/13.d0
		
		if(leis.lt.hours)then
		    stat=1
		else
		    stat=0
		endif
		

		aux=max(phi1*(consN**phi-1.d0) + alfad(age)*theta1*(leisN**theta-1.d0), 0.000000001d0)
		
		
	
		utility = chi1*( aux**chi)*exp(mu*stat)
	
		
			
	
end function utility
!______________________________________________
double precision function margutc(cons, leis, age)
	 
		double precision cons, leis, aux, aux1, conse,consN,leisN
		integer age, stat
		
		conse=cons/equival(age)
		
		consN=conse/13.d0
		leisN=leis/13.d0
		
		if(leis.lt.hours)then
		    stat=1
		else
		    stat=0
		endif
		
		aux=phi1*(consN**phi-1.d0) + alfad(age)*theta1*(leisN**theta-1.d0)
				
		aux1=aux**(chi-1.d0)
		margutc = aux1*exp(mu*stat)*(consN**(phi-1.d0) )/ equival(age)
				
end function margutc

!______________________________________________
double precision function margutl(cons, leis, age)
	 
		double precision cons, leis, aux, aux1, conse,consN,leisN
		integer age, stat
		
		conse=cons/equival(age)
		
		consN=conse/13.d0
		leisN=leis/13.d0
		
		if(leis.lt.hours)then
		    stat=1
		else
		    stat=0
		endif

		aux=phi1*(consN**phi-1.d0) + alfad(age)*theta1*(leisN**theta-1.d0)
				
		aux1=aux**(chi-1.d0)
		margutl = aux1*alfad(age)*exp(mu*stat)*(leisN**(theta-1.d0) )
				
end function margutl

!______________________________________________
double precision function ucc(cons, leis, age)
double precision cons, leis, aux, aux1, conse,consN,leisN
		integer age, stat

        conse=cons/equival(age)
		
		consN=conse/13.d0
		leisN=leis/13.d0
		
		if(leis.lt.hours)then
		    stat=1
		else
		    stat=0
		endif
	
        aux=phi1*(consN**phi-1.d0) + alfad(age)*theta1*(leisN**theta-1.d0)
		aux1=aux**(chi-1.d0)
		ucc = aux1*exp(mu*stat)*(consN**(phi-2.d0) )*((chi-1.d0)*(consN**phi)/aux + (phi-1.d0))/ equival(age)

end function ucc
!______________________________________________
double precision function ull(cons, leis, age)
double precision cons, leis, aux, aux1, conse,consN,leisN
		integer age, stat

        conse=cons/equival(age)
		
		consN=conse/13.d0
		leisN=leis/13.d0
		
		if(leis.lt.hours)then
		    stat=1
		else
		    stat=0
		endif
		 
		aux=phi1*(consN**phi-1.d0) + alfad(age)*theta1*(leisN**theta-1.d0)
		aux1=aux**(chi-1.d0)
		ull = aux1*alfad(age)*exp(mu*stat)*(leisN**(theta-2.d0) )* ((chi-1.d0)*alfad(age)*(leisN**theta)/aux + (theta-1.d0))
        
end function ull
!_______          _______________________________________

double precision function ucl(cons, leis, age)
double precision cons, leis, aux, aux1, conse,consN,leisN
		integer age, stat

        conse=cons/equival(age)
		
		consN=conse/13.d0
		leisN=leis/13.d0
		
		if(leis.lt.hours)then
		    stat=1
		else
		    stat=0
		endif

		    
	    aux=phi1*(consN**phi-1.d0) + alfad(age)*theta1*(leisN**theta-1.d0)
	    aux1=aux**(chi-2.d0)
	    ucl = exp(mu*stat)*(consN**(phi-1.d0))*(chi-1.d0)*aux1*alfad(age)*(leisN**(theta-1.d0))/ equival(age)
    
end function ucl
!_______          _______________________________________


subroutine find(fage, fass, fnodeas, fmina, faet,fxet,stat)

	integer fage, fmina, fnodeas, jl, jm, ju , stat
	double precision atmin, atmax, atdiff, fass, faet, fxet, inteta

		   if (stat.ge.1) then 
			
			  jl=0
			  ju=na+1
812			  if (ju-jl.gt.1) then
				jm = (ju+jl)/2
				if (fass.gt.xawork(jm,fnodeas,fage) ) then
					jl = jm
				else
					ju = jm
				endif
				goto 812
			  endif
			  fmina = jl
			  if (fmina.eq.na) then
				fmina = na-1
			  elseif (fmina.eq.0) then
                fmina = 1
			  endif
  
			  atmin  = xawork(fmina,fnodeas, fage)       
			  atmax  = xawork(fmina+1,fnodeas, fage)       
			  atdiff = atmax - atmin  

		
		   else 
			
			  jl=0
			  ju=na+1
813			  if (ju-jl.gt.1) then
				jm = (ju+jl)/2
				if (fass.gt.xanon(jm,fnodeas,fage) ) then
				
					jl = jm
				else
					ju = jm
				endif
				goto 813
			  endif
			  fmina = jl
			  if (fmina.eq.na) then
				fmina = na-1
			  elseif (fmina.eq.0) then
                fmina = 1
			  endif
  
			  atmin  = xanon(fmina,fnodeas, fage)       
			  atmax  = xanon(fmina+1,fnodeas, fage)       

			  

			  atdiff = atmax - atmin  

	
		   endif


			  inteta = (2.d0*fass -atmax - atmin)/ atdiff          
			  faet = 0.5d0*(1.d0-inteta          )
			  fxet = 0.5d0*(1.d0+inteta          )

end subroutine find
!______________________________________________
double precision function deltaperF(humcap)
double precision humcap

    if (humcap.le.0.5d0) then 
        deltaperF = 0.d0 
    else
        deltaperF = deltaper1 * humcap
    endif


	if (humcap*(1.d0 - deltaperF).lt.0.5d0) then
        deltaperF = (humcap - 0.5d0) / humcap
	endif

end function deltaperF

!______________________________________________
end module params

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
